<?php
namespace vesdk;

class Cpr extends Base
{
    const CPR_API = "/render/charge/cpr/request";

    public function request($data)
    {
        $checkRes = $this->checkParam($data, $this->ruleCpr());
        if ($checkRes["res"] === false)
        {
            return $checkRes;
        }
        //对特殊参数 replaceableJson 和 assetUrls 进行互斥检查
        if (empty($data["replaceableJson"]) && empty($data["assetUrls"]))
        {
            return ["res" => false, "message" => "replaceableJson & assetUrls one of them must have value"];
        }

        return $this->post($data, self::CPR_API);
    }


    //仅做最基本的规则检查,部分参数是array,还是需要参照文档进行提交
    public function ruleCpr()
    {
        return [
            "tplId"           => "required|string",
            "tplType"         => "required|int",
            "tplVersion"      => "required|int",
            "tplUrl"          => "required|string",
            "recordId"        => "required|string",
            "replaceableJson" => "any|string",
            "assetUrls"       => "any|array",
            "musicUrl"        => "any|string",
            "musicLoop"       => "any|int",
            "subAssetUrls"    => "any|array",
            "subTexts"        => "any|array",
            "ossId"           => "required|string",
            "notifyUrl"       => "required|string",
            "uploadKey"       => 'required|string|^\/',//不以/开头
            "audioTracks"     => "any|array", // 替换音轨
            "setting"         => "any|int"
        ];
    }

}
